/*
################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################
*/

#ifndef QML_ZHTTP_CLIENT_H
#define QML_ZHTTP_CLIENT_H

#include <QtQml>

#include <czmq.h>
#include "qml_czmq_plugin.h"


class QmlZhttpClient : public QObject
{
    Q_OBJECT
    Q_PROPERTY(bool isNULL READ isNULL)

public:
    zhttp_client_t *self;

    QmlZhttpClient() { self = NULL; }
    bool isNULL() { return self == NULL; }

    static QObject* qmlAttachedProperties(QObject* object); // defined in QmlZhttpClient.cpp

public slots:
    //  Send a get request to the url, headers is optional.
    //      Use arg to identify response when making multiple requests simultaneously.
    //      Timeout is in milliseconds, use -1 or 0 to wait indefinitely.
    int get (const QString &url, QmlZlistx *headers, int timeout, zhttp_client_fn handler, void *arg);

    //  Send a post request to the url, headers is optional.
    //  Use arg to identify response when making multiple requests simultaneously.
    //  Timeout is in milliseconds, use -1 or 0 to wait indefinitely.
    int post (const QString &url, QmlZlistx *headers, QmlZchunk *body, int timeout, zhttp_client_fn handler, void *arg);

    //  Invoke callback function for received responses.
    //  Should be call after zpoller wait method.
    //  Returns 0 if OK, -1 on failure.
    int execute ();

    //  Wait until a response is ready to be consumed.
    //  Use when you need a synchronize response.
    //
    //  The timeout should be zero or greater, or -1 to wait indefinitely.
    //
    //  Returns 0 if a response is ready, -1 and otherwise. errno will be set to EAGAIN if no response is ready.
    int wait (int timeout);
};

class QmlZhttpClientAttached : public QObject
{
    Q_OBJECT
    QObject* m_attached;

public:
    QmlZhttpClientAttached (QObject* attached) {
        Q_UNUSED (attached);
    };

public slots:
    //  Self test of this class.
    void test (bool verbose);

    //  Create a new http client
    QmlZhttpClient *construct (bool verbose);

    //  Destroy an http client
    void destruct (QmlZhttpClient *qmlSelf);
};


QML_DECLARE_TYPEINFO(QmlZhttpClient, QML_HAS_ATTACHED_PROPERTIES)

#endif
/*
################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################
*/
