/*
################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################
*/
#ifndef Q_ZHTTP_CLIENT_H
#define Q_ZHTTP_CLIENT_H

#include "qczmq.h"

class QT_CZMQ_EXPORT QZhttpClient : public QObject
{
    Q_OBJECT
public:

    //  Copy-construct to return the proper wrapped c types
    QZhttpClient (zhttp_client_t *self, QObject *qObjParent = 0);

    //  Create a new http client
    explicit QZhttpClient (bool verbose, QObject *qObjParent = 0);

    //  Destroy an http client
    ~QZhttpClient ();

    //  Send a get request to the url, headers is optional.
    //      Use arg to identify response when making multiple requests simultaneously.
    //      Timeout is in milliseconds, use -1 or 0 to wait indefinitely.
    int get (const QString &url, QZlistx *headers, int timeout, zhttp_client_fn handler, void *arg);

    //  Send a post request to the url, headers is optional.
    //  Use arg to identify response when making multiple requests simultaneously.
    //  Timeout is in milliseconds, use -1 or 0 to wait indefinitely.
    int post (const QString &url, QZlistx *headers, QZchunk *body, int timeout, zhttp_client_fn handler, void *arg);

    //  Invoke callback function for received responses.
    //  Should be call after zpoller wait method.
    //  Returns 0 if OK, -1 on failure.
    int execute ();

    //  Wait until a response is ready to be consumed.
    //  Use when you need a synchronize response.
    //
    //  The timeout should be zero or greater, or -1 to wait indefinitely.
    //
    //  Returns 0 if a response is ready, -1 and otherwise. errno will be set to EAGAIN if no response is ready.
    int wait (int timeout);

    //  Self test of this class.
    static void test (bool verbose);

    zhttp_client_t *self;
};
#endif //  Q_ZHTTP_CLIENT_H
/*
################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################
*/
